package demos;

import ucs.*;

/** UCSpv demo doing online learning on the 11mux problem.
 *  @author Gavin Brown
 */
public class BasicUCSpv {

	////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////
		
	public static void main( String [] args )
	{
		UCSconfig params = new UCSconfig();
		
		params.setFitnessFunction(new UCSpvFitness() );
		params.setSystemPredictor(new UCSpvSysPredictor() );
		params.setProblem("./data/11mux.csv");
		
		UCS myucs = new UCS(params);
		
		//run for 20000, printing at intervals of 500
		myucs.run(30000, 500);
		myucs.pop.printMacros();
	}

	////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////	

}//end class
