package demos;

import ucs.*;
import dataprocessing.*;

/** UCS demo doing online learning on the 11mux problem with a minimal fitness function. Otherwise
    this is the same as the BasicUCS demo
 *  @author Tim Kovacs
 */
public class MinimalMonks
{
	////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////
	
	public static void main( String [] args )
	{
		UCSconfig params = new UCSconfig();
		params.setFitnessFunction(new MinimalFitness() );
		params.setProblem("./data/monks3.train.csv");

		
		UCS myucs = new UCS(params);

		//run for 20000, printing at intervals of 500
		myucs.run(20000, 500);
		myucs.pop.printMacros();

	}
	
	////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////
	
}//end class
