package demos;

import ucs.*;

/** UCSpv demo doing online learning on the Monks-3 problem.
 *  @author Gavin Brown
 */
public class Monks {

	////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////
		
	public static void main( String [] args )
	{
		UCSconfig params = new UCSconfig();
		
		params.setFitnessFunction(new UCSpvFitness() );
		params.setSystemPredictor(new UCSpvSysPredictor() );
		params.setProblem("./data/monks3.train.csv");
		
		UCS myucs = new UCS(params);
		
		//run for 20000, printing at intervals of 500
		myucs.run(20000, 500);
	}

	////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////	

}//end class
